from twisted.application import service, internet

from axiom.store import Store

from shs.controller import ServicesController
from shs.nickserv import NickServ
from shs.ares import AresServ
from shs.oper import OperServ
from shs.protocol import ServicesFactory, InspircdServices

def deploy(host, port, dbname, dbuser, dbpass, **params):
    application = service.Application('shs')

    store = Store('shs.axiom')

    def ctrlFactory():
        ctrl = ServicesController(store, params)
        ctrl.addService(NickServ(ctrl))
        ctrl.addService(AresServ(ctrl))
        ctrl.addService(OperServ(ctrl))
        return ctrl

    services = internet.TCPClient(host, port, ServicesFactory(ctrlFactory, InspircdServices))
    services.setServiceParent(application)

    return application
