from twisted.trial.unittest import TestCase

from shs.nickserv import NickServ

class NickServTests(TestCase):
    def setUp(self):
        self.store = None
        self.nickserv = NickServ(self)

    def test_collide(self):
        self.nickserv.scheduleCollision('foo', 30)
        self.assertIn('foo', self.nickserv.collisions)
        self.nickserv.cancelCollision('foo')
        self.assertNotIn('foo', self.nickserv.collisions)

    def test_doubleCollide(self):
        self.nickserv.scheduleCollision('foo', 30)
        self.nickserv.scheduleCollision('foo', 30)
        self.assertIn('foo', self.nickserv.collisions)
        self.nickserv.cancelCollision('foo')

    def test_noneCollide(self):
        self.nickserv.cancelCollision('foo')

    def test_doubleCollide(self):
        self.nickserv.scheduleCollision('foo', 30)
        self.nickserv.cancelCollision('foo')
        self.nickserv.cancelCollision('foo')
        self.assertNotIn('foo', self.nickserv.collisions)
